...
1#!/usr/bin/env bash
2
3# Copyright 2018 The Kubernetes Authors.
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# This script verifies the build without in-tree cloud providers.
18# Usage: `hack/verify-typecheck-providerless.sh`.
19
20set -o errexit
21set -o nounset
22set -o pipefail
23
24KUBE_ROOT=$(dirname "${BASH_SOURCE[0]}")/..
25
26cd "${KUBE_ROOT}"
27# verify the providerless build
28# https://github.com/kubernetes/enhancements/blob/master/keps/sig-cloud-provider/1179-building-without-in-tree-providers/README.md
29hack/verify-typecheck.sh --skip-test --tags=providerless
30
31# verify using go list
32if _out="$(go list -mod=readonly -tags "providerless" -e -json k8s.io/kubernetes/cmd/kubelet/... \
33 | grep -e Azure/azure-sdk-for-go -e github.com/aws/aws-sdk-go -e google.golang.org/api)"; then
34 echo "${_out}" >&2
35 echo "Verify typecheck for providerless tag failed. Found restricted packages." >&2
36 exit 1
37fi
38if _out="$(go list -mod=readonly -tags "providerless" -e -json k8s.io/kubernetes/cmd/kube-apiserver/... \
39 | grep -e Azure/azure-sdk-for-go -e github.com/aws/aws-sdk-go -e google.golang.org/api \
40 -e Azure/go-autorest -e oauth2/google)"; then
41 echo "${_out}" >&2
42 echo "Verify typecheck for providerless tag failed. Found restricted packages." >&2
43 exit 1
44fi
View as plain text